︠f2bdca0d-b072-4142-9e78-258c9d50caeds︠
#######################
#Bifurcation Diagram 2D
#by Sinan Kapcak
#2017
#www.k-interact.net/dds
#######################

a,x,y=var('a x y')
@interact
def _(
    f=input_box(label='$f(x,y)=$',default=a*y/(x^2 + y+1),width=60),
    g=input_box(label='$g(x,y)=$',default=x/(y^2 + x+1),width=60),
    P0=input_box(default=( n(.6,digits=3),n(.2,digits=3 )),label='$(x_0,y_0)$',width=35),
    parameter=input_box(default=(0,4),label='Interval for $a$',width=35),#,auto_update=False
    iterasyon=input_box(default=200,label='Quality Parameter#1',width=12),#number of iterations: 400 is good
    subint=input_box(default=200,label='Quality Parameter#2',width=12),#number of subinterval: 500 is good
    figs=slider(2, 20, 1, default=6,label='Figure size'),
    ar=slider([2^n for n in [-10..10]], default=1,label='Aspect Ratio' )
):
    paramin=parameter[0]
    paramax=parameter[1]
    kk=(paramax-paramin)/subint
    paralist=[paramin+i*kk for i in range(1+subint) ]
    biflistx=[]
    biflisty=[]
    for j in range(len(paralist)):
        nok=[(P0[0],P0[1] )]#list of points
        for i in range(iterasyon):
            nok.append((f(x=nok[i][0],y=nok[i][1],a=paralist[j] ),g(x=nok[i][0],y=nok[i][1],a=paralist[j])))
        nok_x=[ nok[-m][0] for m in [1..(iterasyon*2/5)] ]
        nok_y=[ nok[-m][1] for m in [1..(iterasyon*2/5)] ]
        for mm in range(len(nok_x)):
            biflistx.append( [paralist[j] ,nok_x[mm]])
            biflisty.append( [paralist[j] ,nok_y[mm]])
    biflistgrafx=list_plot(biflistx, plotjoined=False, color='grey',alpha=.3,pointsize=1)
    biflistgrafy=list_plot(biflisty, plotjoined=False, color='red',alpha=.3,pointsize=1)
    graf=biflistgrafx+biflistgrafy
    show(graf,frame=False,axes=True,axes_labels=['$a$','$x_n,y_n$'],figsize=figs,aspect_ratio=ar)
︡75087b68-1969-46d4-8ff9-a04edeb42194︡{"interact":{"controls":[{"control_type":"input-box","default":"a*y/(x^2 + y + 1)","label":"$f(x,y)=$","nrows":1,"readonly":false,"submit_button":null,"type":null,"var":"f","width":60},{"control_type":"input-box","default":"x/(y^2 + x + 1)","label":"$g(x,y)=$","nrows":1,"readonly":false,"submit_button":null,"type":null,"var":"g","width":60},{"control_type":"input-box","default":"(0.600, 0.200)","label":"$(x_0,y_0)$","nrows":1,"readonly":false,"submit_button":null,"type":null,"var":"P0","width":35},{"control_type":"input-box","default":"(0, 4)","label":"Interval for $a$","nrows":1,"readonly":false,"submit_button":null,"type":null,"var":"parameter","width":35},{"control_type":"input-box","default":200,"label":"Quality Parameter#1","nrows":1,"readonly":false,"submit_button":null,"type":null,"var":"iterasyon","width":12},{"control_type":"input-box","default":200,"label":"Quality Parameter#2","nrows":1,"readonly":false,"submit_button":null,"type":null,"var":"subint","width":12},{"animate":true,"control_type":"slider","default":4,"display_value":true,"label":"Figure size","vals":["2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20"],"var":"figs","width":null},{"animate":true,"control_type":"slider","default":10,"display_value":true,"label":"Aspect Ratio","vals":["1/1024","1/512","1/256","1/128","1/64","1/32","1/16","1/8","1/4","1/2","1","2","4","8","16","32","64","128","256","512","1024"],"var":"ar","width":null}],"flicker":false,"id":"58390f96-c9dd-4903-aec8-d24b1f4e1267","layout":[[["f",12,null]],[["g",12,null]],[["P0",12,null]],[["parameter",12,null]],[["iterasyon",12,null]],[["subint",12,null]],[["figs",12,null]],[["ar",12,null]],[["",12,null]]],"style":"None"}}︡{"done":true}︡
︠29977b69-574b-4ac5-94de-6b1e80ccbbc2︠









